#include "owl.h"

int owl_popwin_init(owl_popwin *pw) {
  pw->active=0;
  return(0);
}

int owl_popwin_up(owl_popwin *pw) {
  int lines, cols;

  lines=owl_global_get_lines(&g);
  cols=owl_global_get_cols(&g);
  pw->borderwin=newwin(lines/2, (cols/4)*3, lines/4, cols/8);
  pw->popwin=newwin(lines/2-2, (cols/4)*3-2, lines/4+1, cols/8+1);

  meta(pw->popwin,TRUE);

  nodelay(pw->popwin, 1);
  idlok(pw->popwin, 1);

  werase(pw->popwin);
  werase(pw->borderwin);
  box(pw->borderwin, 0, 0);
  wnoutrefresh(pw->popwin);
  wnoutrefresh(pw->borderwin);
  owl_global_set_needrefresh(&g);
  pw->active=1;
  return(0);
}

int owl_popwin_display_text(owl_popwin *pw, char *text) {
  waddstr(pw->popwin, text);
  wnoutrefresh(pw->popwin);
  owl_global_set_needrefresh(&g);
  return(0);
}
					      
int owl_popwin_getch(owl_popwin *pw) {
  int j;

  if (pw->handler == NULL) return(-1);
  
  touchwin(pw->popwin);
  j=wgetch(pw->popwin);
  return((* pw->handler)(j));
}

int owl_popwin_close(owl_popwin *pw) {
  delwin(pw->popwin);
  delwin(pw->borderwin);
  pw->active=0;
  owl_mainwin_redisplay(owl_global_get_mainwin(&g));
  return(0);
}

int owl_popwin_is_active(owl_popwin *pw) {
  if (pw->active==1) return(1);
  return(0);
}

int owl_popwin_refresh(owl_popwin *pw) {
  /* this will refresh the border as well as the text area */
  touchwin(pw->borderwin);
  touchwin(pw->popwin);
  wnoutrefresh(pw->borderwin);
  wnoutrefresh(pw->popwin);
  owl_global_set_needrefresh(&g);
  return(0);
}

void owl_popwin_set_handler(owl_popwin *pw, int (*func)(int ch)) {
  pw->handler=func;
}

void owl_popwin_unset_handler(owl_popwin *pw) {
  pw->handler=NULL;
}
